% SHARED SKETCH ALGORITHM FOR LEARNING ACTIVE BASIS
%% Load in exponential model, mex C codes, and set parameters
% ExponentialModel; % this line is not needed if 'storedExponentialModel' exists
clear; close all; 
load storedExponentialModel; 
mex Cflatness.c; % learning by shared sketch algorithm
mex Csigmoid.c; % local normalization
%% Load in training images
imageOption = 1; resizeFactor = .9; % resize images to specified ratio, and use the common upper-left portion 
%imageOption = 2; sizex = 120; sizey = 120; % resize images to specified common height and width
%imageOption = 3; sizey = 120; % resize images to have common width without changing their aspect ratios, and use the common horizontal central line
imageFolder = 'positiveImage'; % folder of training images  
imageName = dir([imageFolder '/*.jpg']);
numImage = size(imageName, 1); % number of training images 
I = cell(1, numImage); 
flatnessMap = cell(1, numImage); 
LoadImage; 
allSizex = zeros(1, numImage)+sizex; 
allSizey = zeros(1, numImage)+sizey; 
%% Compute SUM1 maps by Gabor filtering
disp(['start filtering']); tic
if (imageOption == 3) 
    [SUM1map, Ifill] = ApplyFilterfftFill(I, allFilter, localOrNot, localHalfx, localHalfy, thresholdFactor); % SUM1 maps by Gabor filtering
    I = Ifill; 
else 
    SUM1map = ApplyFilterfftSame(I, allFilter, localOrNot, localHalfx, localHalfy, -1, thresholdFactor);% SUM1 maps by Gabor filtering
end
Csigmoid(numImage, allSizex, allSizey, numOrient, saturation, SUM1map);
disp(['filtering time: ' num2str(toc) ' seconds']);
%% Computing flatness 
for (a = 0:4:12)
overallFlatnessMap = single(zeros(sizex, sizey)); 
for (img = 1 : numImage)
    flatnessMap = single(zeros(sizex, sizey)); 
    Cflatness(sizex, sizey, numOrient, halfFilterSize, a, a, SUM1map(img, :), flatnessMap); 
    overallFlatnessMap = overallFlatnessMap + flatnessMap; 
end 
Outepsgif(-overallFlatnessMap, ['HorseEXP3Average' num2str(a)]);
end

